/*
 * PlayerList.java
 *
 * Created on 10 giugno 2004, 12.00
 */

import java.util.*;

/**
 *
 * @author  campi
 */
public class PlayerList extends Vector
{
    public void addElement(Player Object)
    {
        // Aggiungi un giocatore (il tipo player  comunque sempre vero)
        super.addElement(Object);
    }
    
    public void addElement(Object Object)
    {
        if(Object instanceof Player)
        {
            super.addElement(Object);
        }
    }
    
    public void remove(String username)
    {
        // Cancella  (se esiste) un giocatore  cercandolo per username
        if (existUsername(username))
        {
            super.remove(findUsername(username));
        }
    }
    
    public boolean existUsername(String username)
    {
        if(findUsername(username)!=-1)
            return true;
        else
            return false;
    }
    
    private int findUsername(String username)
    {
        // Ritorna la posizione del giocatore cercandolo per nome
        for (int i=0; i < this.size();i++)
        {
            if(((Player)this.elementAt(i)).getUsername().equals(username))
                return i;
        }
        
        return -1;
    }
    
    public Player findPlayer(String username)
    {
        // Ritorna la posizione del giocatore cercandolo per nome
        for (int i=0; i < this.size();i++)
        {
            Player p=(Player)this.elementAt(i);
            
            if(p.getUsername().equals(username))
                return p;
        }
        
        return null;
    }
    
    // Ritorna il punteggio di un giocatore cercandolo per nome
    public int findRecord(String username)
    {
        int i=findUsername(username);
        
        if(i!=-1)
            return ((Player)this.elementAt(i)).getRecord();
        else
            return -1;
    }
    
    public boolean checkRecord(int ScoreToCheck)
    {
        // Ritorna True se il punteggio passato come parametro  maggiore
        // dell'attuale HighScore
        
        boolean isRecord=true;
        
        for(int i=0;i<this.size();i++)
        {
            int r=((Player)this.elementAt(i)).getRecord();
            if (ScoreToCheck < r)
            {
                isRecord=false;
            }
        }
        
        return isRecord;
    }
    
    public String toString()
    {
        String str=new String();
        
        for (int i=0; i < this.size();i++)
        {
            str+=((Player)this.elementAt(i)).toString()+"\n";
        }
        
        return str;
    }
}

