/*
 * ServeOneClient.java
 *
 * Created on 10 giugno 2004, 16.03
 */

import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.Integer;

/**
 *
 * @author  campi
 */
class ServeOneClient extends Thread
{
    private static int numServer=0;
    private int id=numServer++;
    
    private Socket socket;
    private BufferedReader inSocket;
    private PrintWriter outSocket;
    private BufferedReader inKeyboard;
    private PrintWriter outVideo;
    
    private PlayerList pl;
    private Player p;
    
    public ServeOneClient(Socket s,PlayerList pll)
    {
        try
        {
            pl=pll;
            p=null;

            System.out.println("Il client "+id+" tenta di connettersi");

            socket = s;
            //canali di comunicazione
            inSocket = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            outSocket = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
            inKeyboard = new BufferedReader(new InputStreamReader(System.in));
            outVideo = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)), true);

            System.out.println("Client "+id+" connesso");

            start();
        }
        catch(Exception e)
        {
            System.out.println("Exception: e="+e);
            e.printStackTrace();
            
            try
            {
                socket.close();
            }
            catch(Exception ex)
            {}
        }
    }
    
    public void run()
    {
        login();
        gioca();
        chiudi();
    }
    
    private void login()
    {
        try
        {
            while(true)
            {
                String msg;
            
                msg=inSocket.readLine();
                outVideo.println(msg);

                String username=inSocket.readLine();
                String password=inSocket.readLine();

                outVideo.println("Ricevuti username="+username+" password="+password);

                p=pl.findPlayer(username);

                if(p==null)
                {
                    p=new Player(username,password);
                    pl.addElement(p);
                }

                if(p.checkPassword(password))
                {
                    outSocket.println("true");
                    break;
                }
                else
                {
                    p=null;
                    outSocket.println("false");
                }
            }
            
        }
        catch(Exception e)
        {
            System.out.println("Exception: e="+e);
            e.printStackTrace();
            
            try
            {
                socket.close();
            }
            catch(Exception ex)
            {}
        }
    }
    
    private void gioca()
    {
        try
        {
            while(true)
            {
                //codice partite
                outVideo.println("Inizio risposta client "+id+"\n");
                String msg=inSocket.readLine();
                outVideo.println("msg = "+msg);

                if(msg.equals("partita"))
                {
                    partita();
                }
                else if(msg.equals("record"))
                {
                    inviaRecord();
                }
                else if(msg.equals("fine"))
                {
                    outVideo.println("Il client "+id+" ha finito di giocare");
                    break;
                }
                else
                    System.out.println("ERRORE");
            }
        }
        catch(Exception e)
        {
            System.out.println("Exception: e="+e);
            e.printStackTrace();
            
            try
            {
                socket.close();
            }
            catch(Exception ex)
            {}
        }
    }
    
    private void partita() throws Exception
    {
        boolean continua=true;
        int i=0;
        while(continua)
        {
            i++;
            String sequenza=generaSequenza(i);
            outVideo.println("Inviata a client "+id+" la sequenza: "+sequenza);
            outSocket.println(sequenza);

            String sequenzaRicevuta=inSocket.readLine();
            outVideo.println("Sequenza inviata da client "+id+": "+sequenza);

            if(!sequenza.equals(sequenzaRicevuta))
            {
                outSocket.println("false");
                p.checkRecord(i-1);
                continua=false;
                outVideo.println("Sequenza sbagliata\n");
            }
            else
            {
                outSocket.println("true");
                outVideo.println("Sequenza corretta\n");
            }
        }
    }
    
    private void inviaRecord() throws Exception
    {
        outVideo.println("Inviata classifica al client "+id);
        
        String numeroGiocatori=""+pl.size();
        String classifica=pl.toString();
        outVideo.println(classifica);
        outSocket.println(numeroGiocatori);
        for(int i=0;i<pl.size();i++)
            outSocket.println(((Player)pl.get(i)).toString());
    }
    
    private void chiudi()
    {
        try
        {
            socket.close();
        }
        catch(Exception e)
        {
            System.out.println("Exception: e="+e);
            e.printStackTrace();
            
            try
            {
                socket.close();
            }
            catch(Exception ex)
            {}
        }
    }
    
    private String generaSequenza(int i)
    {
        String result=new String();
        
        for(int j=0;j<i;j++)
        {
            int num=(int)(Math.random()*10);
            
            if(num==10)
                num=0;
            
            result+=num;
        }
        
        return result;
    }
}

