 import java.net.*;
import java.io.*;

public class Client
{
    private final static int PORT=3000;
    private final static int NUMSPAZI=100;

    private final static String address="localhost";

    private Socket socket;
    private BufferedReader inSocket;
    private PrintWriter outSocket;
    private BufferedReader inKeyboard;
    private PrintWriter outVideo;
   

  
    
    public Client()
    {
        System.out.println("Client avviato");
        
        try
        {
            esegui();
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
        }
        finally
        {
            // Always close it:
            try {
                socket.close();
            } catch(IOException e) {
                System.err.println("Socket not closed");
            }
        }
    }
    
    private void connetti()
    {
        try
        {
            System.out.println("Il client tenta di connettersi");

            socket = new Socket(address, PORT);
            //canali di comunicazione
            inSocket = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            outSocket = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
            inKeyboard = new BufferedReader(new InputStreamReader(System.in));
            outVideo = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)), true);
            
            System.out.println("Client connesso");
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();

            // Always close it:
            try {
                socket.close();
            } catch(IOException ex) {
                System.err.println("Socket not closed");
            }
        }
    }
    
    
    private void esegui()
    {
        try
        {
            connetti();
            login();
            interagisci();
            chiudi();
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
        }
        finally
        {
            // Always close it:
            try {
                socket.close();
            } catch(IOException e) {
                System.err.println("Socket not closed");
            }
        }
    }
    
    
    private void interagisci()
    {
        while(true)
        {
            outVideo.println("");
            outVideo.println("Scegliere cosa si vuol fare");
            outVideo.println("a --> aggiungi meta");
            outVideo.println("v --> valuta una meta");
            outVideo.println("p --> vedi meta preferita");
            outVideo.println("q --> esci");
            
            try
            {
                String scelta=inKeyboard.readLine();

                if(scelta.equals("a"))
                    aggiuntaMeta();
                else if(scelta.equals("v"))
                    vediValutazioni();
                else if(scelta.equals("p"))
                    vediMigliore();
                else if(scelta.equals("q"))
                {
                    outSocket.println("fine");
                    outVideo.println("ARRIVEDERCI!!!!!");
                    break;
                }
                else
                    outVideo.println("INPUT ERRATO");
            }
            catch(Exception e)
            {
                System.out.println("Exception: "+e);
                e.printStackTrace();
                
                // Always close it:
                try
                {
                    socket.close();
                }
                catch(IOException ex)
                {
                    System.err.println("Socket not closed");
                }
            }
        }
    }
    
    private void aggiuntaMeta()
    {
        try
        {
            //codice partite
            outVideo.println("Inizio inserimento meta\n");
            outSocket.println("nuova");
            
            outVideo.println("Inserisci luogo\n");
            String luogo=inKeyboard.readLine();
            outSocket.println(luogo);
            
            
            String rispostaServer=inSocket.readLine();
            outVideo.println(rispostaServer);
            
            outVideo.println("Fine inserimento meta\n");
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
                   
            // Always close it:
            try {
                socket.close();
            } catch(IOException ex) {
                System.err.println("Socket not closed");
            }
        }
    }
    
    private void vediValutazioni()
    {
        vediListaMete();
        leggiValutazioniMete();
        aggiungiValutazione();
    }
    
    private void vediListaMete()
    {
        try
        {
            //codice partite
            outVideo.println("Valutazioni");
            
            outSocket.println("valuta");
            
            outVideo.println("Lista mete:");
            int numMete=Integer.parseInt(inSocket.readLine());
            
            for(int i=0;i<numMete;i++)
            {
                String meta=inSocket.readLine();
                outVideo.println(meta);
            }
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
                   
            // Always close it:
            try {
                socket.close();
            } catch(IOException ex) {
                System.err.println("Socket not closed");
            }
        }
    }
    
    private void vediMigliore()
    {
        try
        {
            //codice partite
            outVideo.println("Migliore");
            
            outSocket.println("scelta");
            
            String meta=inSocket.readLine();
                
            outVideo.println(meta);
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
                   
            // Always close it:
            try {
                socket.close();
            } catch(IOException ex) {
                System.err.println("Socket not closed");
            }
        }
    }

    private void leggiValutazioniMete()
    {
        try
        {
            //codice partite
            outVideo.println("Scegli meta");
            String nome=inKeyboard.readLine();
            outSocket.println(nome);
            int numGiudizi=Integer.parseInt(inSocket.readLine());
            
            for(int i=0;i<numGiudizi;i++)
            {
                String voto=inSocket.readLine();
                outVideo.println(voto);
                String giudizio=inSocket.readLine();
                outVideo.println(giudizio);
            }
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
                   
            // Always close it:
            try {
                socket.close();
            } catch(IOException ex) {
                System.err.println("Socket not closed");
            }
        }
    }

    private void aggiungiValutazione()
    {
        try
        {
            //codice partite
            outVideo.println("Vuoi aggiungere giudizio? (S/N)");
            String risposta=inKeyboard.readLine();
            
            if(risposta.equalsIgnoreCase("S"))
            {
                outSocket.println("si");
                
                outVideo.println("Inserisci Voto");
                String voto=inKeyboard.readLine();
                outSocket.println(voto);
            
                outVideo.println("Inserisci Giudizio");
                String giudizio=inKeyboard.readLine();
                outSocket.println(giudizio);
            }
            else
                outSocket.println("no");
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
                   
            // Always close it:
            try {
                socket.close();
            } catch(IOException ex) {
                System.err.println("Socket not closed");
            }
        }
    }

    private void generaBianco()
    {
        for(int i=0;i<NUMSPAZI;i++)
            outVideo.println();
    }
    
    private void chiudi()
    {
        try
        {
            socket.close();
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
        }
        finally
        {
            // Always close it:
            try
            {
                socket.close();
            }
            catch(IOException ex)
            {
                System.err.println("Socket not closed");
            }
        }
    }


    private void login()
    {
        try
        {
            boolean loggato=false;
            
            while(!loggato)
            {
                outVideo.println("Inserire login:");
                String username=inKeyboard.readLine();
                
                outVideo.println("Inserire password:");
                String password=inKeyboard.readLine();
                
                outSocket.println("login");
                outSocket.flush();
                outSocket.println(username);
                outSocket.flush();
                outSocket.println(password);
                outSocket.flush();
                
                loggato=Boolean.valueOf(inSocket.readLine()).booleanValue();
                
                if(loggato)
                    outVideo.println("Login effettuato correttamente");
                else
                    outVideo.println("Nome utente in uso con altra password");
            }
        }
        catch(Exception e)
        {
            System.out.println("Exception: "+e);
            e.printStackTrace();
        
            try {
                socket.close();
            }
            catch(IOException ex)
            {
                System.err.println("Socket not closed");
            }
        }
    }
    
    public static void main(String[] args) throws IOException, InterruptedException
    {
        Client c=new Client();
    }
}